#!/bin/bash

RCOK=`cat /etc/rc.d/rc.conf 2>/dev/null | grep MAC0 | wc -c`
RCOK2=`cat /etc/rc.d/rc.conf 2>/dev/null | grep INTERFACE0 | wc -c`

if (( $(($RCOK))>25 && $(($RCOK2))>10 )); then
	echo "/etc/rc.d/rc.conf is ok."
	exit
fi

echo "/etc/rc.d/rc.conf needs recovery!"

SNHEX=`cat /sys/fsl_otp/HW_OCOTP_CUST0 2>/dev/null`
SN=`echo $(($SNHEX))`                 

SNHEX2=`cat /sys/fsl_otp/HW_OCOTP_CUST1 2>/dev/null`
SN2=`echo $(($SNHEX2))`                 

if (( $((SN2))>0 )); then
	SNHEX=$SNHEX2
	SN=$SN2
fi

BADSN=0

if (( $((SN))<=0 )); then
	echo "SERIAL NUMBER NOT FOUND IN CPU OTP ROM"
	
	OLDSN=`cat /root/config/system.xml 2>/dev/null | grep serialNumber | sed "s/.serialNumber.//" | sed "s/..serialNumber.//" | sed "s/[ \t]*//"`
	if (( $(($OLDSN))>0 )); then
		echo "SERIAL NUMBER RECOVERED FROM system.xml FILE"

		SN=$OLDSN
	else
		BADSN=1
	fi
else
	SN=`echo $(($SNHEX + 200))`
fi

if (( $((BADSN))<=0 )); then
	echo "SERIAL NUMBER: $SN"
	
	MACA=`printf "%02X\n" "$(( ( ($SN) - 200) % 256  ))"`
	MACB=`printf "%02X\n" "$(( ( ($SN) - 200) / 256 + 2 ))"`
	MAC=`echo "00:db:db:db:${MACB}:${MACA}"`
else
	echo "NO SERIAL NUMBER LOCATED : GENERATING RANDOM MAC ADDRESS"
	
	MACA=`printf "%02X\n" "$(( ($RANDOM) % 256  ))"`
	MACB=`printf "%02X\n" "$(( ($RANDOM) % 256  ))"`
	MACC=`printf "%02X\n" "$(( ($RANDOM) % 256  ))"`
	MAC=`echo "00:db:bb:${MACA}:${MACB}:${MACC}"`
fi

echo "MAC ADDRESS: $MAC"

rm /etc/rc.d/rc.recovered 2>/dev/null
echo "all_services=\"mount-proc-sys mdev udev hostname devfsd depmod modules filesystems syslog network inetd portmap dropbear sshd boa smb dhcpd settime fslgnome watchdog bluetooth gtk2 pango\"" > /etc/rc.d/rc.conf.recovered
echo "all_services_r=\"pango gtk2 bluetooth watchdog fslgnome settime dhcpd smb boa sshd dropbear portmap inetd network syslog filesystems modules depmod devfsd hostname udev mdev mount-proc-sys\"" >> /etc/rc.d/rc.conf.recovered
echo "" >> /etc/rc.d/rc.conf.recovered
echo "cfg_services=\"mount-proc-sys  udev hostname  depmod modules filesystems  network inetd  dropbear     settime     \"" >> /etc/rc.d/rc.conf.recovered
echo "" >> /etc/rc.d/rc.conf.recovered
echo "cfg_services_r=\"     settime     dropbear  inetd network  filesystems modules depmod  hostname udev  mount-proc-sys\"" >> /etc/rc.d/rc.conf.recovered
echo "" >> /etc/rc.d/rc.conf.recovered
echo "export HOSTNAME=\"mx28\"" >> /etc/rc.d/rc.conf.recovered
echo "export NTP_SERVER=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export MODLIST=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export RAMDIRS=\"/tmp /var\"" >> /etc/rc.d/rc.conf.recovered
echo "export TMPFS=\"tmpfs\"" >> /etc/rc.d/rc.conf.recovered
echo "export TMPFS_SIZE=\"512k\"" >> /etc/rc.d/rc.conf.recovered
echo "export READONLY_FS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export INETD_ARGS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export BOA_ARGS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export SMBD_ARGS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export NMBD_ARGS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export DHCP_ARG=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "export DEPLOYMENT_STYLE=\"JFFS2\"" >> /etc/rc.d/rc.conf.recovered
echo "export SYSCFG_DHCPC_CMD=\"udhcpc -b -i \"" >> /etc/rc.d/rc.conf.recovered
echo "export DROPBEAR_ARGS=\"\"" >> /etc/rc.d/rc.conf.recovered
echo "# net interface 0" >> /etc/rc.d/rc.conf.recovered
echo "export SYSCFG_IFACE0=y" >> /etc/rc.d/rc.conf.recovered
echo "export INTERFACE0=\"eth0\"" >> /etc/rc.d/rc.conf.recovered
echo "export MAC0=\"$MAC\"" >> /etc/rc.d/rc.conf.recovered
echo "export IPADDR0=\"dhcp\"" >> /etc/rc.d/rc.conf.recovered
echo "# net interface 1" >> /etc/rc.d/rc.conf.recovered
echo "export SYSCFG_IFACE1=n" >> /etc/rc.d/rc.conf.recovered
echo "#export INTERFACE1=\"eth1\"" >> /etc/rc.d/rc.conf.recovered
echo "#export IPADDR1=\"192.168.1.5\"" >> /etc/rc.d/rc.conf.recovered
echo "#export NETMASK1=\"255.255.255.0\"" >> /etc/rc.d/rc.conf.recovered
echo "#export BROADCAST1=\"192.168.1.255\"" >> /etc/rc.d/rc.conf.recovered
echo "#export GATEWAY1=\"192.168.1.2\"" >> /etc/rc.d/rc.conf.recovered
echo "#export NAMESERVER1=\"192.168.0.130\"" >> /etc/rc.d/rc.conf.recovered

mv /etc/rc.d/rc.conf /etc/rc.d/rc.conf.recover-backup 2>/dev/null
mv /etc/rc.d/rc.conf.recovered /etc/rc.d/rc.conf

echo "/etc/rc.d/rc.conf recovered!"

