#!/bin/sh

. /etc/rc.d/rc.conf

LD_LIBRARY_PATH=/usr/local/lib
export LD_LIBRARY_PATH=/usr/local/lib

if [ -e /root/config/ntp_enabled ]; then
	/root/scada-timekeeping X
	/root/scada-timekeeping X
	/root/scada-timekeeping X
fi

killall netwatch.sh
/root/netwatch.sh &
if [ -e /root/config/ntp_enabled ]; then
	killall watchtime.sh scada-timekeeping
	/root/watchtime.sh &
fi

while [[ 1 ]]; do
	cd /root
	
	killall scada-io-process scada-storage-process scada-display-process
	killall scada-comm-eth scada-comm-serial scada-snmp
	killall modbus-serial modbus-tcp modbus-master-serial
	killall serial-streamer morningstar-rd1 serial-wits
	killall dgh-d5251 geopsi-g6
	killall watchtime.sh scada-timekeeping
	killall scada-cellmodem

	if [ -e ./data/updates/update.pkg ]; then
		cd /root/data/updates
		tar xvzf update.pkg
		rm update.pkg
		if [ -e update.sh ]; then
			./update.sh
		fi
		cd /root
	fi
	
	/root/recover-rc.conf.sh

	if [ -e ./data/updates/needs_reboot ]; then
		rm ./data/updates/needs_reboot
		reboot
		sleep 100
	fi
	
	if [ -e /root/config/ntp_enabled ]; then
		killall watchtime.sh scada-timekeeping
		/root/watchtime.sh &
	fi
	
	cd /root
	/root/scada
	
	sleep 2
done
